package org.xtext.example.mydsl.ide.contentassist.antlr.internal;

import java.io.InputStream;
import org.eclipse.xtext.*;
import org.eclipse.xtext.parser.*;
import org.eclipse.xtext.parser.impl.*;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.parser.antlr.XtextTokenStream;
import org.eclipse.xtext.parser.antlr.XtextTokenStream.HiddenTokens;
import org.eclipse.xtext.ide.editor.contentassist.antlr.internal.AbstractInternalContentAssistParser;
import org.eclipse.xtext.ide.editor.contentassist.antlr.internal.DFA;
import org.xtext.example.mydsl.services.MyDslGrammarAccess;



import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class InternalMyDslParser extends AbstractInternalContentAssistParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "RULE_ID", "RULE_INT", "RULE_STRING", "RULE_ML_COMMENT", "RULE_SL_COMMENT", "RULE_WS", "RULE_ANY_OTHER", "'use'", "'Hello'", "'!'", "'user'", "'age'", "'='"
    };
    public static final int RULE_ID=4;
    public static final int RULE_WS=9;
    public static final int RULE_STRING=6;
    public static final int RULE_ANY_OTHER=10;
    public static final int RULE_SL_COMMENT=8;
    public static final int T__15=15;
    public static final int T__16=16;
    public static final int RULE_INT=5;
    public static final int T__11=11;
    public static final int RULE_ML_COMMENT=7;
    public static final int T__12=12;
    public static final int T__13=13;
    public static final int T__14=14;
    public static final int EOF=-1;

    // delegates
    // delegators


        public InternalMyDslParser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public InternalMyDslParser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        

    public String[] getTokenNames() { return InternalMyDslParser.tokenNames; }
    public String getGrammarFileName() { return "InternalMyDsl.g"; }


    	private MyDslGrammarAccess grammarAccess;

    	public void setGrammarAccess(MyDslGrammarAccess grammarAccess) {
    		this.grammarAccess = grammarAccess;
    	}

    	@Override
    	protected Grammar getGrammar() {
    		return grammarAccess.getGrammar();
    	}

    	@Override
    	protected String getValueForTokenName(String tokenName) {
    		return tokenName;
    	}



    // $ANTLR start "entryRuleModel"
    // InternalMyDsl.g:53:1: entryRuleModel : ruleModel EOF ;
    public final void entryRuleModel() throws RecognitionException {
        try {
            // InternalMyDsl.g:54:1: ( ruleModel EOF )
            // InternalMyDsl.g:55:1: ruleModel EOF
            {
             before(grammarAccess.getModelRule()); 
            pushFollow(FOLLOW_1);
            ruleModel();

            state._fsp--;

             after(grammarAccess.getModelRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleModel"


    // $ANTLR start "ruleModel"
    // InternalMyDsl.g:62:1: ruleModel : ( ( rule__Model__Alternatives )* ) ;
    public final void ruleModel() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:66:2: ( ( ( rule__Model__Alternatives )* ) )
            // InternalMyDsl.g:67:2: ( ( rule__Model__Alternatives )* )
            {
            // InternalMyDsl.g:67:2: ( ( rule__Model__Alternatives )* )
            // InternalMyDsl.g:68:3: ( rule__Model__Alternatives )*
            {
             before(grammarAccess.getModelAccess().getAlternatives()); 
            // InternalMyDsl.g:69:3: ( rule__Model__Alternatives )*
            loop1:
            do {
                int alt1=2;
                int LA1_0 = input.LA(1);

                if ( ((LA1_0>=11 && LA1_0<=12)||LA1_0==14) ) {
                    alt1=1;
                }


                switch (alt1) {
            	case 1 :
            	    // InternalMyDsl.g:69:4: rule__Model__Alternatives
            	    {
            	    pushFollow(FOLLOW_3);
            	    rule__Model__Alternatives();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop1;
                }
            } while (true);

             after(grammarAccess.getModelAccess().getAlternatives()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleModel"


    // $ANTLR start "entryRuleUse"
    // InternalMyDsl.g:78:1: entryRuleUse : ruleUse EOF ;
    public final void entryRuleUse() throws RecognitionException {
        try {
            // InternalMyDsl.g:79:1: ( ruleUse EOF )
            // InternalMyDsl.g:80:1: ruleUse EOF
            {
             before(grammarAccess.getUseRule()); 
            pushFollow(FOLLOW_1);
            ruleUse();

            state._fsp--;

             after(grammarAccess.getUseRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleUse"


    // $ANTLR start "ruleUse"
    // InternalMyDsl.g:87:1: ruleUse : ( ( rule__Use__Group__0 ) ) ;
    public final void ruleUse() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:91:2: ( ( ( rule__Use__Group__0 ) ) )
            // InternalMyDsl.g:92:2: ( ( rule__Use__Group__0 ) )
            {
            // InternalMyDsl.g:92:2: ( ( rule__Use__Group__0 ) )
            // InternalMyDsl.g:93:3: ( rule__Use__Group__0 )
            {
             before(grammarAccess.getUseAccess().getGroup()); 
            // InternalMyDsl.g:94:3: ( rule__Use__Group__0 )
            // InternalMyDsl.g:94:4: rule__Use__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__Use__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getUseAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleUse"


    // $ANTLR start "entryRuleGreeting"
    // InternalMyDsl.g:103:1: entryRuleGreeting : ruleGreeting EOF ;
    public final void entryRuleGreeting() throws RecognitionException {
        try {
            // InternalMyDsl.g:104:1: ( ruleGreeting EOF )
            // InternalMyDsl.g:105:1: ruleGreeting EOF
            {
             before(grammarAccess.getGreetingRule()); 
            pushFollow(FOLLOW_1);
            ruleGreeting();

            state._fsp--;

             after(grammarAccess.getGreetingRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleGreeting"


    // $ANTLR start "ruleGreeting"
    // InternalMyDsl.g:112:1: ruleGreeting : ( ( rule__Greeting__Group__0 ) ) ;
    public final void ruleGreeting() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:116:2: ( ( ( rule__Greeting__Group__0 ) ) )
            // InternalMyDsl.g:117:2: ( ( rule__Greeting__Group__0 ) )
            {
            // InternalMyDsl.g:117:2: ( ( rule__Greeting__Group__0 ) )
            // InternalMyDsl.g:118:3: ( rule__Greeting__Group__0 )
            {
             before(grammarAccess.getGreetingAccess().getGroup()); 
            // InternalMyDsl.g:119:3: ( rule__Greeting__Group__0 )
            // InternalMyDsl.g:119:4: rule__Greeting__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__Greeting__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getGreetingAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleGreeting"


    // $ANTLR start "entryRuleUser"
    // InternalMyDsl.g:128:1: entryRuleUser : ruleUser EOF ;
    public final void entryRuleUser() throws RecognitionException {
        try {
            // InternalMyDsl.g:129:1: ( ruleUser EOF )
            // InternalMyDsl.g:130:1: ruleUser EOF
            {
             before(grammarAccess.getUserRule()); 
            pushFollow(FOLLOW_1);
            ruleUser();

            state._fsp--;

             after(grammarAccess.getUserRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleUser"


    // $ANTLR start "ruleUser"
    // InternalMyDsl.g:137:1: ruleUser : ( ( rule__User__Group__0 ) ) ;
    public final void ruleUser() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:141:2: ( ( ( rule__User__Group__0 ) ) )
            // InternalMyDsl.g:142:2: ( ( rule__User__Group__0 ) )
            {
            // InternalMyDsl.g:142:2: ( ( rule__User__Group__0 ) )
            // InternalMyDsl.g:143:3: ( rule__User__Group__0 )
            {
             before(grammarAccess.getUserAccess().getGroup()); 
            // InternalMyDsl.g:144:3: ( rule__User__Group__0 )
            // InternalMyDsl.g:144:4: rule__User__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__User__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getUserAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleUser"


    // $ANTLR start "rule__Model__Alternatives"
    // InternalMyDsl.g:152:1: rule__Model__Alternatives : ( ( ( rule__Model__GreetingsAssignment_0 ) ) | ( ( rule__Model__UsersAssignment_1 ) ) | ( ( rule__Model__UsesAssignment_2 ) ) );
    public final void rule__Model__Alternatives() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:156:1: ( ( ( rule__Model__GreetingsAssignment_0 ) ) | ( ( rule__Model__UsersAssignment_1 ) ) | ( ( rule__Model__UsesAssignment_2 ) ) )
            int alt2=3;
            switch ( input.LA(1) ) {
            case 12:
                {
                alt2=1;
                }
                break;
            case 14:
                {
                alt2=2;
                }
                break;
            case 11:
                {
                alt2=3;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 2, 0, input);

                throw nvae;
            }

            switch (alt2) {
                case 1 :
                    // InternalMyDsl.g:157:2: ( ( rule__Model__GreetingsAssignment_0 ) )
                    {
                    // InternalMyDsl.g:157:2: ( ( rule__Model__GreetingsAssignment_0 ) )
                    // InternalMyDsl.g:158:3: ( rule__Model__GreetingsAssignment_0 )
                    {
                     before(grammarAccess.getModelAccess().getGreetingsAssignment_0()); 
                    // InternalMyDsl.g:159:3: ( rule__Model__GreetingsAssignment_0 )
                    // InternalMyDsl.g:159:4: rule__Model__GreetingsAssignment_0
                    {
                    pushFollow(FOLLOW_2);
                    rule__Model__GreetingsAssignment_0();

                    state._fsp--;


                    }

                     after(grammarAccess.getModelAccess().getGreetingsAssignment_0()); 

                    }


                    }
                    break;
                case 2 :
                    // InternalMyDsl.g:163:2: ( ( rule__Model__UsersAssignment_1 ) )
                    {
                    // InternalMyDsl.g:163:2: ( ( rule__Model__UsersAssignment_1 ) )
                    // InternalMyDsl.g:164:3: ( rule__Model__UsersAssignment_1 )
                    {
                     before(grammarAccess.getModelAccess().getUsersAssignment_1()); 
                    // InternalMyDsl.g:165:3: ( rule__Model__UsersAssignment_1 )
                    // InternalMyDsl.g:165:4: rule__Model__UsersAssignment_1
                    {
                    pushFollow(FOLLOW_2);
                    rule__Model__UsersAssignment_1();

                    state._fsp--;


                    }

                     after(grammarAccess.getModelAccess().getUsersAssignment_1()); 

                    }


                    }
                    break;
                case 3 :
                    // InternalMyDsl.g:169:2: ( ( rule__Model__UsesAssignment_2 ) )
                    {
                    // InternalMyDsl.g:169:2: ( ( rule__Model__UsesAssignment_2 ) )
                    // InternalMyDsl.g:170:3: ( rule__Model__UsesAssignment_2 )
                    {
                     before(grammarAccess.getModelAccess().getUsesAssignment_2()); 
                    // InternalMyDsl.g:171:3: ( rule__Model__UsesAssignment_2 )
                    // InternalMyDsl.g:171:4: rule__Model__UsesAssignment_2
                    {
                    pushFollow(FOLLOW_2);
                    rule__Model__UsesAssignment_2();

                    state._fsp--;


                    }

                     after(grammarAccess.getModelAccess().getUsesAssignment_2()); 

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Model__Alternatives"


    // $ANTLR start "rule__Use__Group__0"
    // InternalMyDsl.g:179:1: rule__Use__Group__0 : rule__Use__Group__0__Impl rule__Use__Group__1 ;
    public final void rule__Use__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:183:1: ( rule__Use__Group__0__Impl rule__Use__Group__1 )
            // InternalMyDsl.g:184:2: rule__Use__Group__0__Impl rule__Use__Group__1
            {
            pushFollow(FOLLOW_4);
            rule__Use__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Use__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Use__Group__0"


    // $ANTLR start "rule__Use__Group__0__Impl"
    // InternalMyDsl.g:191:1: rule__Use__Group__0__Impl : ( 'use' ) ;
    public final void rule__Use__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:195:1: ( ( 'use' ) )
            // InternalMyDsl.g:196:1: ( 'use' )
            {
            // InternalMyDsl.g:196:1: ( 'use' )
            // InternalMyDsl.g:197:2: 'use'
            {
             before(grammarAccess.getUseAccess().getUseKeyword_0()); 
            match(input,11,FOLLOW_2); 
             after(grammarAccess.getUseAccess().getUseKeyword_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Use__Group__0__Impl"


    // $ANTLR start "rule__Use__Group__1"
    // InternalMyDsl.g:206:1: rule__Use__Group__1 : rule__Use__Group__1__Impl ;
    public final void rule__Use__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:210:1: ( rule__Use__Group__1__Impl )
            // InternalMyDsl.g:211:2: rule__Use__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Use__Group__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Use__Group__1"


    // $ANTLR start "rule__Use__Group__1__Impl"
    // InternalMyDsl.g:217:1: rule__Use__Group__1__Impl : ( ( rule__Use__ImportURIAssignment_1 ) ) ;
    public final void rule__Use__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:221:1: ( ( ( rule__Use__ImportURIAssignment_1 ) ) )
            // InternalMyDsl.g:222:1: ( ( rule__Use__ImportURIAssignment_1 ) )
            {
            // InternalMyDsl.g:222:1: ( ( rule__Use__ImportURIAssignment_1 ) )
            // InternalMyDsl.g:223:2: ( rule__Use__ImportURIAssignment_1 )
            {
             before(grammarAccess.getUseAccess().getImportURIAssignment_1()); 
            // InternalMyDsl.g:224:2: ( rule__Use__ImportURIAssignment_1 )
            // InternalMyDsl.g:224:3: rule__Use__ImportURIAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__Use__ImportURIAssignment_1();

            state._fsp--;


            }

             after(grammarAccess.getUseAccess().getImportURIAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Use__Group__1__Impl"


    // $ANTLR start "rule__Greeting__Group__0"
    // InternalMyDsl.g:233:1: rule__Greeting__Group__0 : rule__Greeting__Group__0__Impl rule__Greeting__Group__1 ;
    public final void rule__Greeting__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:237:1: ( rule__Greeting__Group__0__Impl rule__Greeting__Group__1 )
            // InternalMyDsl.g:238:2: rule__Greeting__Group__0__Impl rule__Greeting__Group__1
            {
            pushFollow(FOLLOW_4);
            rule__Greeting__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Greeting__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Greeting__Group__0"


    // $ANTLR start "rule__Greeting__Group__0__Impl"
    // InternalMyDsl.g:245:1: rule__Greeting__Group__0__Impl : ( 'Hello' ) ;
    public final void rule__Greeting__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:249:1: ( ( 'Hello' ) )
            // InternalMyDsl.g:250:1: ( 'Hello' )
            {
            // InternalMyDsl.g:250:1: ( 'Hello' )
            // InternalMyDsl.g:251:2: 'Hello'
            {
             before(grammarAccess.getGreetingAccess().getHelloKeyword_0()); 
            match(input,12,FOLLOW_2); 
             after(grammarAccess.getGreetingAccess().getHelloKeyword_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Greeting__Group__0__Impl"


    // $ANTLR start "rule__Greeting__Group__1"
    // InternalMyDsl.g:260:1: rule__Greeting__Group__1 : rule__Greeting__Group__1__Impl rule__Greeting__Group__2 ;
    public final void rule__Greeting__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:264:1: ( rule__Greeting__Group__1__Impl rule__Greeting__Group__2 )
            // InternalMyDsl.g:265:2: rule__Greeting__Group__1__Impl rule__Greeting__Group__2
            {
            pushFollow(FOLLOW_5);
            rule__Greeting__Group__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Greeting__Group__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Greeting__Group__1"


    // $ANTLR start "rule__Greeting__Group__1__Impl"
    // InternalMyDsl.g:272:1: rule__Greeting__Group__1__Impl : ( ( rule__Greeting__UserAssignment_1 ) ) ;
    public final void rule__Greeting__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:276:1: ( ( ( rule__Greeting__UserAssignment_1 ) ) )
            // InternalMyDsl.g:277:1: ( ( rule__Greeting__UserAssignment_1 ) )
            {
            // InternalMyDsl.g:277:1: ( ( rule__Greeting__UserAssignment_1 ) )
            // InternalMyDsl.g:278:2: ( rule__Greeting__UserAssignment_1 )
            {
             before(grammarAccess.getGreetingAccess().getUserAssignment_1()); 
            // InternalMyDsl.g:279:2: ( rule__Greeting__UserAssignment_1 )
            // InternalMyDsl.g:279:3: rule__Greeting__UserAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__Greeting__UserAssignment_1();

            state._fsp--;


            }

             after(grammarAccess.getGreetingAccess().getUserAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Greeting__Group__1__Impl"


    // $ANTLR start "rule__Greeting__Group__2"
    // InternalMyDsl.g:287:1: rule__Greeting__Group__2 : rule__Greeting__Group__2__Impl ;
    public final void rule__Greeting__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:291:1: ( rule__Greeting__Group__2__Impl )
            // InternalMyDsl.g:292:2: rule__Greeting__Group__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Greeting__Group__2__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Greeting__Group__2"


    // $ANTLR start "rule__Greeting__Group__2__Impl"
    // InternalMyDsl.g:298:1: rule__Greeting__Group__2__Impl : ( '!' ) ;
    public final void rule__Greeting__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:302:1: ( ( '!' ) )
            // InternalMyDsl.g:303:1: ( '!' )
            {
            // InternalMyDsl.g:303:1: ( '!' )
            // InternalMyDsl.g:304:2: '!'
            {
             before(grammarAccess.getGreetingAccess().getExclamationMarkKeyword_2()); 
            match(input,13,FOLLOW_2); 
             after(grammarAccess.getGreetingAccess().getExclamationMarkKeyword_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Greeting__Group__2__Impl"


    // $ANTLR start "rule__User__Group__0"
    // InternalMyDsl.g:314:1: rule__User__Group__0 : rule__User__Group__0__Impl rule__User__Group__1 ;
    public final void rule__User__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:318:1: ( rule__User__Group__0__Impl rule__User__Group__1 )
            // InternalMyDsl.g:319:2: rule__User__Group__0__Impl rule__User__Group__1
            {
            pushFollow(FOLLOW_4);
            rule__User__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__User__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__User__Group__0"


    // $ANTLR start "rule__User__Group__0__Impl"
    // InternalMyDsl.g:326:1: rule__User__Group__0__Impl : ( 'user' ) ;
    public final void rule__User__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:330:1: ( ( 'user' ) )
            // InternalMyDsl.g:331:1: ( 'user' )
            {
            // InternalMyDsl.g:331:1: ( 'user' )
            // InternalMyDsl.g:332:2: 'user'
            {
             before(grammarAccess.getUserAccess().getUserKeyword_0()); 
            match(input,14,FOLLOW_2); 
             after(grammarAccess.getUserAccess().getUserKeyword_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__User__Group__0__Impl"


    // $ANTLR start "rule__User__Group__1"
    // InternalMyDsl.g:341:1: rule__User__Group__1 : rule__User__Group__1__Impl rule__User__Group__2 ;
    public final void rule__User__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:345:1: ( rule__User__Group__1__Impl rule__User__Group__2 )
            // InternalMyDsl.g:346:2: rule__User__Group__1__Impl rule__User__Group__2
            {
            pushFollow(FOLLOW_6);
            rule__User__Group__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__User__Group__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__User__Group__1"


    // $ANTLR start "rule__User__Group__1__Impl"
    // InternalMyDsl.g:353:1: rule__User__Group__1__Impl : ( ( rule__User__NameAssignment_1 ) ) ;
    public final void rule__User__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:357:1: ( ( ( rule__User__NameAssignment_1 ) ) )
            // InternalMyDsl.g:358:1: ( ( rule__User__NameAssignment_1 ) )
            {
            // InternalMyDsl.g:358:1: ( ( rule__User__NameAssignment_1 ) )
            // InternalMyDsl.g:359:2: ( rule__User__NameAssignment_1 )
            {
             before(grammarAccess.getUserAccess().getNameAssignment_1()); 
            // InternalMyDsl.g:360:2: ( rule__User__NameAssignment_1 )
            // InternalMyDsl.g:360:3: rule__User__NameAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__User__NameAssignment_1();

            state._fsp--;


            }

             after(grammarAccess.getUserAccess().getNameAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__User__Group__1__Impl"


    // $ANTLR start "rule__User__Group__2"
    // InternalMyDsl.g:368:1: rule__User__Group__2 : rule__User__Group__2__Impl ;
    public final void rule__User__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:372:1: ( rule__User__Group__2__Impl )
            // InternalMyDsl.g:373:2: rule__User__Group__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__User__Group__2__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__User__Group__2"


    // $ANTLR start "rule__User__Group__2__Impl"
    // InternalMyDsl.g:379:1: rule__User__Group__2__Impl : ( ( rule__User__Group_2__0 )? ) ;
    public final void rule__User__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:383:1: ( ( ( rule__User__Group_2__0 )? ) )
            // InternalMyDsl.g:384:1: ( ( rule__User__Group_2__0 )? )
            {
            // InternalMyDsl.g:384:1: ( ( rule__User__Group_2__0 )? )
            // InternalMyDsl.g:385:2: ( rule__User__Group_2__0 )?
            {
             before(grammarAccess.getUserAccess().getGroup_2()); 
            // InternalMyDsl.g:386:2: ( rule__User__Group_2__0 )?
            int alt3=2;
            int LA3_0 = input.LA(1);

            if ( (LA3_0==15) ) {
                alt3=1;
            }
            switch (alt3) {
                case 1 :
                    // InternalMyDsl.g:386:3: rule__User__Group_2__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__User__Group_2__0();

                    state._fsp--;


                    }
                    break;

            }

             after(grammarAccess.getUserAccess().getGroup_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__User__Group__2__Impl"


    // $ANTLR start "rule__User__Group_2__0"
    // InternalMyDsl.g:395:1: rule__User__Group_2__0 : rule__User__Group_2__0__Impl rule__User__Group_2__1 ;
    public final void rule__User__Group_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:399:1: ( rule__User__Group_2__0__Impl rule__User__Group_2__1 )
            // InternalMyDsl.g:400:2: rule__User__Group_2__0__Impl rule__User__Group_2__1
            {
            pushFollow(FOLLOW_7);
            rule__User__Group_2__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__User__Group_2__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__User__Group_2__0"


    // $ANTLR start "rule__User__Group_2__0__Impl"
    // InternalMyDsl.g:407:1: rule__User__Group_2__0__Impl : ( 'age' ) ;
    public final void rule__User__Group_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:411:1: ( ( 'age' ) )
            // InternalMyDsl.g:412:1: ( 'age' )
            {
            // InternalMyDsl.g:412:1: ( 'age' )
            // InternalMyDsl.g:413:2: 'age'
            {
             before(grammarAccess.getUserAccess().getAgeKeyword_2_0()); 
            match(input,15,FOLLOW_2); 
             after(grammarAccess.getUserAccess().getAgeKeyword_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__User__Group_2__0__Impl"


    // $ANTLR start "rule__User__Group_2__1"
    // InternalMyDsl.g:422:1: rule__User__Group_2__1 : rule__User__Group_2__1__Impl rule__User__Group_2__2 ;
    public final void rule__User__Group_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:426:1: ( rule__User__Group_2__1__Impl rule__User__Group_2__2 )
            // InternalMyDsl.g:427:2: rule__User__Group_2__1__Impl rule__User__Group_2__2
            {
            pushFollow(FOLLOW_8);
            rule__User__Group_2__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__User__Group_2__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__User__Group_2__1"


    // $ANTLR start "rule__User__Group_2__1__Impl"
    // InternalMyDsl.g:434:1: rule__User__Group_2__1__Impl : ( '=' ) ;
    public final void rule__User__Group_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:438:1: ( ( '=' ) )
            // InternalMyDsl.g:439:1: ( '=' )
            {
            // InternalMyDsl.g:439:1: ( '=' )
            // InternalMyDsl.g:440:2: '='
            {
             before(grammarAccess.getUserAccess().getEqualsSignKeyword_2_1()); 
            match(input,16,FOLLOW_2); 
             after(grammarAccess.getUserAccess().getEqualsSignKeyword_2_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__User__Group_2__1__Impl"


    // $ANTLR start "rule__User__Group_2__2"
    // InternalMyDsl.g:449:1: rule__User__Group_2__2 : rule__User__Group_2__2__Impl ;
    public final void rule__User__Group_2__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:453:1: ( rule__User__Group_2__2__Impl )
            // InternalMyDsl.g:454:2: rule__User__Group_2__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__User__Group_2__2__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__User__Group_2__2"


    // $ANTLR start "rule__User__Group_2__2__Impl"
    // InternalMyDsl.g:460:1: rule__User__Group_2__2__Impl : ( ( rule__User__AgeAssignment_2_2 ) ) ;
    public final void rule__User__Group_2__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:464:1: ( ( ( rule__User__AgeAssignment_2_2 ) ) )
            // InternalMyDsl.g:465:1: ( ( rule__User__AgeAssignment_2_2 ) )
            {
            // InternalMyDsl.g:465:1: ( ( rule__User__AgeAssignment_2_2 ) )
            // InternalMyDsl.g:466:2: ( rule__User__AgeAssignment_2_2 )
            {
             before(grammarAccess.getUserAccess().getAgeAssignment_2_2()); 
            // InternalMyDsl.g:467:2: ( rule__User__AgeAssignment_2_2 )
            // InternalMyDsl.g:467:3: rule__User__AgeAssignment_2_2
            {
            pushFollow(FOLLOW_2);
            rule__User__AgeAssignment_2_2();

            state._fsp--;


            }

             after(grammarAccess.getUserAccess().getAgeAssignment_2_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__User__Group_2__2__Impl"


    // $ANTLR start "rule__Model__GreetingsAssignment_0"
    // InternalMyDsl.g:476:1: rule__Model__GreetingsAssignment_0 : ( ruleGreeting ) ;
    public final void rule__Model__GreetingsAssignment_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:480:1: ( ( ruleGreeting ) )
            // InternalMyDsl.g:481:2: ( ruleGreeting )
            {
            // InternalMyDsl.g:481:2: ( ruleGreeting )
            // InternalMyDsl.g:482:3: ruleGreeting
            {
             before(grammarAccess.getModelAccess().getGreetingsGreetingParserRuleCall_0_0()); 
            pushFollow(FOLLOW_2);
            ruleGreeting();

            state._fsp--;

             after(grammarAccess.getModelAccess().getGreetingsGreetingParserRuleCall_0_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Model__GreetingsAssignment_0"


    // $ANTLR start "rule__Model__UsersAssignment_1"
    // InternalMyDsl.g:491:1: rule__Model__UsersAssignment_1 : ( ruleUser ) ;
    public final void rule__Model__UsersAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:495:1: ( ( ruleUser ) )
            // InternalMyDsl.g:496:2: ( ruleUser )
            {
            // InternalMyDsl.g:496:2: ( ruleUser )
            // InternalMyDsl.g:497:3: ruleUser
            {
             before(grammarAccess.getModelAccess().getUsersUserParserRuleCall_1_0()); 
            pushFollow(FOLLOW_2);
            ruleUser();

            state._fsp--;

             after(grammarAccess.getModelAccess().getUsersUserParserRuleCall_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Model__UsersAssignment_1"


    // $ANTLR start "rule__Model__UsesAssignment_2"
    // InternalMyDsl.g:506:1: rule__Model__UsesAssignment_2 : ( ruleUse ) ;
    public final void rule__Model__UsesAssignment_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:510:1: ( ( ruleUse ) )
            // InternalMyDsl.g:511:2: ( ruleUse )
            {
            // InternalMyDsl.g:511:2: ( ruleUse )
            // InternalMyDsl.g:512:3: ruleUse
            {
             before(grammarAccess.getModelAccess().getUsesUseParserRuleCall_2_0()); 
            pushFollow(FOLLOW_2);
            ruleUse();

            state._fsp--;

             after(grammarAccess.getModelAccess().getUsesUseParserRuleCall_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Model__UsesAssignment_2"


    // $ANTLR start "rule__Use__ImportURIAssignment_1"
    // InternalMyDsl.g:521:1: rule__Use__ImportURIAssignment_1 : ( RULE_ID ) ;
    public final void rule__Use__ImportURIAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:525:1: ( ( RULE_ID ) )
            // InternalMyDsl.g:526:2: ( RULE_ID )
            {
            // InternalMyDsl.g:526:2: ( RULE_ID )
            // InternalMyDsl.g:527:3: RULE_ID
            {
             before(grammarAccess.getUseAccess().getImportURIIDTerminalRuleCall_1_0()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getUseAccess().getImportURIIDTerminalRuleCall_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Use__ImportURIAssignment_1"


    // $ANTLR start "rule__Greeting__UserAssignment_1"
    // InternalMyDsl.g:536:1: rule__Greeting__UserAssignment_1 : ( ( RULE_ID ) ) ;
    public final void rule__Greeting__UserAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:540:1: ( ( ( RULE_ID ) ) )
            // InternalMyDsl.g:541:2: ( ( RULE_ID ) )
            {
            // InternalMyDsl.g:541:2: ( ( RULE_ID ) )
            // InternalMyDsl.g:542:3: ( RULE_ID )
            {
             before(grammarAccess.getGreetingAccess().getUserUserCrossReference_1_0()); 
            // InternalMyDsl.g:543:3: ( RULE_ID )
            // InternalMyDsl.g:544:4: RULE_ID
            {
             before(grammarAccess.getGreetingAccess().getUserUserIDTerminalRuleCall_1_0_1()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getGreetingAccess().getUserUserIDTerminalRuleCall_1_0_1()); 

            }

             after(grammarAccess.getGreetingAccess().getUserUserCrossReference_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Greeting__UserAssignment_1"


    // $ANTLR start "rule__User__NameAssignment_1"
    // InternalMyDsl.g:555:1: rule__User__NameAssignment_1 : ( RULE_ID ) ;
    public final void rule__User__NameAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:559:1: ( ( RULE_ID ) )
            // InternalMyDsl.g:560:2: ( RULE_ID )
            {
            // InternalMyDsl.g:560:2: ( RULE_ID )
            // InternalMyDsl.g:561:3: RULE_ID
            {
             before(grammarAccess.getUserAccess().getNameIDTerminalRuleCall_1_0()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getUserAccess().getNameIDTerminalRuleCall_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__User__NameAssignment_1"


    // $ANTLR start "rule__User__AgeAssignment_2_2"
    // InternalMyDsl.g:570:1: rule__User__AgeAssignment_2_2 : ( RULE_INT ) ;
    public final void rule__User__AgeAssignment_2_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:574:1: ( ( RULE_INT ) )
            // InternalMyDsl.g:575:2: ( RULE_INT )
            {
            // InternalMyDsl.g:575:2: ( RULE_INT )
            // InternalMyDsl.g:576:3: RULE_INT
            {
             before(grammarAccess.getUserAccess().getAgeINTTerminalRuleCall_2_2_0()); 
            match(input,RULE_INT,FOLLOW_2); 
             after(grammarAccess.getUserAccess().getAgeINTTerminalRuleCall_2_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__User__AgeAssignment_2_2"

    // Delegated rules


 

    public static final BitSet FOLLOW_1 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_2 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_3 = new BitSet(new long[]{0x0000000000005802L});
    public static final BitSet FOLLOW_4 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_5 = new BitSet(new long[]{0x0000000000002000L});
    public static final BitSet FOLLOW_6 = new BitSet(new long[]{0x0000000000008000L});
    public static final BitSet FOLLOW_7 = new BitSet(new long[]{0x0000000000010000L});
    public static final BitSet FOLLOW_8 = new BitSet(new long[]{0x0000000000000020L});

}