package org.xtext.example.mydsl.tests

import com.google.inject.Inject
import org.eclipse.xtext.resource.impl.ResourceDescriptionsProvider
import org.eclipse.emf.ecore.EObject
import org.xtext.example.mydsl.myDsl.MyDslPackage

class MyDslIndex {
	@Inject ResourceDescriptionsProvider rdp
	
	def getResourceDescription(EObject o) {
		val index = rdp.getResourceDescriptions(o.eResource)
		index.getResourceDescription(o.eResource.getURI)
	}
	
	def getExportedEObjectDescriptions(EObject o) {
		o.resourceDescription.getExportedObjects
	}
	
	def getExportedEObjectDescriptionsByUser(EObject o) {
		o.resourceDescription.getExportedObjectsByType(MyDslPackage.eINSTANCE.user)
	}
	
	def getExportedEObjectDescriptionsByUse(EObject o) {
		o.resourceDescription.importedNames //getExportedObjectsByType(MyDslPackage.eINSTANCE.use)
	}
}
