package org.xtext.example.mydsl.parser.antlr.internal;

import org.eclipse.xtext.*;
import org.eclipse.xtext.parser.*;
import org.eclipse.xtext.parser.impl.*;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.parser.antlr.AbstractInternalAntlrParser;
import org.eclipse.xtext.parser.antlr.XtextTokenStream;
import org.eclipse.xtext.parser.antlr.XtextTokenStream.HiddenTokens;
import org.eclipse.xtext.parser.antlr.AntlrDatatypeRuleToken;
import org.xtext.example.mydsl.services.MyDslGrammarAccess;



import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class InternalMyDslParser extends AbstractInternalAntlrParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "RULE_ID", "RULE_INT", "RULE_STRING", "RULE_ML_COMMENT", "RULE_SL_COMMENT", "RULE_WS", "RULE_ANY_OTHER", "'use'", "'Hello'", "'!'", "'user'", "'age'", "'='"
    };
    public static final int RULE_ID=4;
    public static final int RULE_WS=9;
    public static final int RULE_STRING=6;
    public static final int RULE_ANY_OTHER=10;
    public static final int RULE_SL_COMMENT=8;
    public static final int T__15=15;
    public static final int T__16=16;
    public static final int RULE_INT=5;
    public static final int T__11=11;
    public static final int RULE_ML_COMMENT=7;
    public static final int T__12=12;
    public static final int T__13=13;
    public static final int T__14=14;
    public static final int EOF=-1;

    // delegates
    // delegators


        public InternalMyDslParser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public InternalMyDslParser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        

    public String[] getTokenNames() { return InternalMyDslParser.tokenNames; }
    public String getGrammarFileName() { return "InternalMyDsl.g"; }



     	private MyDslGrammarAccess grammarAccess;

        public InternalMyDslParser(TokenStream input, MyDslGrammarAccess grammarAccess) {
            this(input);
            this.grammarAccess = grammarAccess;
            registerRules(grammarAccess.getGrammar());
        }

        @Override
        protected String getFirstRuleName() {
        	return "Model";
       	}

       	@Override
       	protected MyDslGrammarAccess getGrammarAccess() {
       		return grammarAccess;
       	}




    // $ANTLR start "entryRuleModel"
    // InternalMyDsl.g:64:1: entryRuleModel returns [EObject current=null] : iv_ruleModel= ruleModel EOF ;
    public final EObject entryRuleModel() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleModel = null;


        try {
            // InternalMyDsl.g:64:46: (iv_ruleModel= ruleModel EOF )
            // InternalMyDsl.g:65:2: iv_ruleModel= ruleModel EOF
            {
             newCompositeNode(grammarAccess.getModelRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleModel=ruleModel();

            state._fsp--;

             current =iv_ruleModel; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleModel"


    // $ANTLR start "ruleModel"
    // InternalMyDsl.g:71:1: ruleModel returns [EObject current=null] : ( ( (lv_greetings_0_0= ruleGreeting ) ) | ( (lv_users_1_0= ruleUser ) ) | ( (lv_uses_2_0= ruleUse ) ) )* ;
    public final EObject ruleModel() throws RecognitionException {
        EObject current = null;

        EObject lv_greetings_0_0 = null;

        EObject lv_users_1_0 = null;

        EObject lv_uses_2_0 = null;



        	enterRule();

        try {
            // InternalMyDsl.g:77:2: ( ( ( (lv_greetings_0_0= ruleGreeting ) ) | ( (lv_users_1_0= ruleUser ) ) | ( (lv_uses_2_0= ruleUse ) ) )* )
            // InternalMyDsl.g:78:2: ( ( (lv_greetings_0_0= ruleGreeting ) ) | ( (lv_users_1_0= ruleUser ) ) | ( (lv_uses_2_0= ruleUse ) ) )*
            {
            // InternalMyDsl.g:78:2: ( ( (lv_greetings_0_0= ruleGreeting ) ) | ( (lv_users_1_0= ruleUser ) ) | ( (lv_uses_2_0= ruleUse ) ) )*
            loop1:
            do {
                int alt1=4;
                switch ( input.LA(1) ) {
                case 12:
                    {
                    alt1=1;
                    }
                    break;
                case 14:
                    {
                    alt1=2;
                    }
                    break;
                case 11:
                    {
                    alt1=3;
                    }
                    break;

                }

                switch (alt1) {
            	case 1 :
            	    // InternalMyDsl.g:79:3: ( (lv_greetings_0_0= ruleGreeting ) )
            	    {
            	    // InternalMyDsl.g:79:3: ( (lv_greetings_0_0= ruleGreeting ) )
            	    // InternalMyDsl.g:80:4: (lv_greetings_0_0= ruleGreeting )
            	    {
            	    // InternalMyDsl.g:80:4: (lv_greetings_0_0= ruleGreeting )
            	    // InternalMyDsl.g:81:5: lv_greetings_0_0= ruleGreeting
            	    {

            	    					newCompositeNode(grammarAccess.getModelAccess().getGreetingsGreetingParserRuleCall_0_0());
            	    				
            	    pushFollow(FOLLOW_3);
            	    lv_greetings_0_0=ruleGreeting();

            	    state._fsp--;


            	    					if (current==null) {
            	    						current = createModelElementForParent(grammarAccess.getModelRule());
            	    					}
            	    					add(
            	    						current,
            	    						"greetings",
            	    						lv_greetings_0_0,
            	    						"org.xtext.example.mydsl.MyDsl.Greeting");
            	    					afterParserOrEnumRuleCall();
            	    				

            	    }


            	    }


            	    }
            	    break;
            	case 2 :
            	    // InternalMyDsl.g:99:3: ( (lv_users_1_0= ruleUser ) )
            	    {
            	    // InternalMyDsl.g:99:3: ( (lv_users_1_0= ruleUser ) )
            	    // InternalMyDsl.g:100:4: (lv_users_1_0= ruleUser )
            	    {
            	    // InternalMyDsl.g:100:4: (lv_users_1_0= ruleUser )
            	    // InternalMyDsl.g:101:5: lv_users_1_0= ruleUser
            	    {

            	    					newCompositeNode(grammarAccess.getModelAccess().getUsersUserParserRuleCall_1_0());
            	    				
            	    pushFollow(FOLLOW_3);
            	    lv_users_1_0=ruleUser();

            	    state._fsp--;


            	    					if (current==null) {
            	    						current = createModelElementForParent(grammarAccess.getModelRule());
            	    					}
            	    					add(
            	    						current,
            	    						"users",
            	    						lv_users_1_0,
            	    						"org.xtext.example.mydsl.MyDsl.User");
            	    					afterParserOrEnumRuleCall();
            	    				

            	    }


            	    }


            	    }
            	    break;
            	case 3 :
            	    // InternalMyDsl.g:119:3: ( (lv_uses_2_0= ruleUse ) )
            	    {
            	    // InternalMyDsl.g:119:3: ( (lv_uses_2_0= ruleUse ) )
            	    // InternalMyDsl.g:120:4: (lv_uses_2_0= ruleUse )
            	    {
            	    // InternalMyDsl.g:120:4: (lv_uses_2_0= ruleUse )
            	    // InternalMyDsl.g:121:5: lv_uses_2_0= ruleUse
            	    {

            	    					newCompositeNode(grammarAccess.getModelAccess().getUsesUseParserRuleCall_2_0());
            	    				
            	    pushFollow(FOLLOW_3);
            	    lv_uses_2_0=ruleUse();

            	    state._fsp--;


            	    					if (current==null) {
            	    						current = createModelElementForParent(grammarAccess.getModelRule());
            	    					}
            	    					add(
            	    						current,
            	    						"uses",
            	    						lv_uses_2_0,
            	    						"org.xtext.example.mydsl.MyDsl.Use");
            	    					afterParserOrEnumRuleCall();
            	    				

            	    }


            	    }


            	    }
            	    break;

            	default :
            	    break loop1;
                }
            } while (true);


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleModel"


    // $ANTLR start "entryRuleUse"
    // InternalMyDsl.g:142:1: entryRuleUse returns [EObject current=null] : iv_ruleUse= ruleUse EOF ;
    public final EObject entryRuleUse() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleUse = null;


        try {
            // InternalMyDsl.g:142:44: (iv_ruleUse= ruleUse EOF )
            // InternalMyDsl.g:143:2: iv_ruleUse= ruleUse EOF
            {
             newCompositeNode(grammarAccess.getUseRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleUse=ruleUse();

            state._fsp--;

             current =iv_ruleUse; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleUse"


    // $ANTLR start "ruleUse"
    // InternalMyDsl.g:149:1: ruleUse returns [EObject current=null] : (otherlv_0= 'use' ( (lv_importURI_1_0= RULE_ID ) ) ) ;
    public final EObject ruleUse() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token lv_importURI_1_0=null;


        	enterRule();

        try {
            // InternalMyDsl.g:155:2: ( (otherlv_0= 'use' ( (lv_importURI_1_0= RULE_ID ) ) ) )
            // InternalMyDsl.g:156:2: (otherlv_0= 'use' ( (lv_importURI_1_0= RULE_ID ) ) )
            {
            // InternalMyDsl.g:156:2: (otherlv_0= 'use' ( (lv_importURI_1_0= RULE_ID ) ) )
            // InternalMyDsl.g:157:3: otherlv_0= 'use' ( (lv_importURI_1_0= RULE_ID ) )
            {
            otherlv_0=(Token)match(input,11,FOLLOW_4); 

            			newLeafNode(otherlv_0, grammarAccess.getUseAccess().getUseKeyword_0());
            		
            // InternalMyDsl.g:161:3: ( (lv_importURI_1_0= RULE_ID ) )
            // InternalMyDsl.g:162:4: (lv_importURI_1_0= RULE_ID )
            {
            // InternalMyDsl.g:162:4: (lv_importURI_1_0= RULE_ID )
            // InternalMyDsl.g:163:5: lv_importURI_1_0= RULE_ID
            {
            lv_importURI_1_0=(Token)match(input,RULE_ID,FOLLOW_2); 

            					newLeafNode(lv_importURI_1_0, grammarAccess.getUseAccess().getImportURIIDTerminalRuleCall_1_0());
            				

            					if (current==null) {
            						current = createModelElement(grammarAccess.getUseRule());
            					}
            					setWithLastConsumed(
            						current,
            						"importURI",
            						lv_importURI_1_0,
            						"org.eclipse.xtext.common.Terminals.ID");
            				

            }


            }


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleUse"


    // $ANTLR start "entryRuleGreeting"
    // InternalMyDsl.g:183:1: entryRuleGreeting returns [EObject current=null] : iv_ruleGreeting= ruleGreeting EOF ;
    public final EObject entryRuleGreeting() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleGreeting = null;


        try {
            // InternalMyDsl.g:183:49: (iv_ruleGreeting= ruleGreeting EOF )
            // InternalMyDsl.g:184:2: iv_ruleGreeting= ruleGreeting EOF
            {
             newCompositeNode(grammarAccess.getGreetingRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleGreeting=ruleGreeting();

            state._fsp--;

             current =iv_ruleGreeting; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleGreeting"


    // $ANTLR start "ruleGreeting"
    // InternalMyDsl.g:190:1: ruleGreeting returns [EObject current=null] : (otherlv_0= 'Hello' ( (otherlv_1= RULE_ID ) ) otherlv_2= '!' ) ;
    public final EObject ruleGreeting() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token otherlv_1=null;
        Token otherlv_2=null;


        	enterRule();

        try {
            // InternalMyDsl.g:196:2: ( (otherlv_0= 'Hello' ( (otherlv_1= RULE_ID ) ) otherlv_2= '!' ) )
            // InternalMyDsl.g:197:2: (otherlv_0= 'Hello' ( (otherlv_1= RULE_ID ) ) otherlv_2= '!' )
            {
            // InternalMyDsl.g:197:2: (otherlv_0= 'Hello' ( (otherlv_1= RULE_ID ) ) otherlv_2= '!' )
            // InternalMyDsl.g:198:3: otherlv_0= 'Hello' ( (otherlv_1= RULE_ID ) ) otherlv_2= '!'
            {
            otherlv_0=(Token)match(input,12,FOLLOW_4); 

            			newLeafNode(otherlv_0, grammarAccess.getGreetingAccess().getHelloKeyword_0());
            		
            // InternalMyDsl.g:202:3: ( (otherlv_1= RULE_ID ) )
            // InternalMyDsl.g:203:4: (otherlv_1= RULE_ID )
            {
            // InternalMyDsl.g:203:4: (otherlv_1= RULE_ID )
            // InternalMyDsl.g:204:5: otherlv_1= RULE_ID
            {

            					if (current==null) {
            						current = createModelElement(grammarAccess.getGreetingRule());
            					}
            				
            otherlv_1=(Token)match(input,RULE_ID,FOLLOW_5); 

            					newLeafNode(otherlv_1, grammarAccess.getGreetingAccess().getUserUserCrossReference_1_0());
            				

            }


            }

            otherlv_2=(Token)match(input,13,FOLLOW_2); 

            			newLeafNode(otherlv_2, grammarAccess.getGreetingAccess().getExclamationMarkKeyword_2());
            		

            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleGreeting"


    // $ANTLR start "entryRuleUser"
    // InternalMyDsl.g:223:1: entryRuleUser returns [EObject current=null] : iv_ruleUser= ruleUser EOF ;
    public final EObject entryRuleUser() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleUser = null;


        try {
            // InternalMyDsl.g:223:45: (iv_ruleUser= ruleUser EOF )
            // InternalMyDsl.g:224:2: iv_ruleUser= ruleUser EOF
            {
             newCompositeNode(grammarAccess.getUserRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleUser=ruleUser();

            state._fsp--;

             current =iv_ruleUser; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleUser"


    // $ANTLR start "ruleUser"
    // InternalMyDsl.g:230:1: ruleUser returns [EObject current=null] : (otherlv_0= 'user' ( (lv_name_1_0= RULE_ID ) ) (otherlv_2= 'age' otherlv_3= '=' ( (lv_age_4_0= RULE_INT ) ) )? ) ;
    public final EObject ruleUser() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token lv_name_1_0=null;
        Token otherlv_2=null;
        Token otherlv_3=null;
        Token lv_age_4_0=null;


        	enterRule();

        try {
            // InternalMyDsl.g:236:2: ( (otherlv_0= 'user' ( (lv_name_1_0= RULE_ID ) ) (otherlv_2= 'age' otherlv_3= '=' ( (lv_age_4_0= RULE_INT ) ) )? ) )
            // InternalMyDsl.g:237:2: (otherlv_0= 'user' ( (lv_name_1_0= RULE_ID ) ) (otherlv_2= 'age' otherlv_3= '=' ( (lv_age_4_0= RULE_INT ) ) )? )
            {
            // InternalMyDsl.g:237:2: (otherlv_0= 'user' ( (lv_name_1_0= RULE_ID ) ) (otherlv_2= 'age' otherlv_3= '=' ( (lv_age_4_0= RULE_INT ) ) )? )
            // InternalMyDsl.g:238:3: otherlv_0= 'user' ( (lv_name_1_0= RULE_ID ) ) (otherlv_2= 'age' otherlv_3= '=' ( (lv_age_4_0= RULE_INT ) ) )?
            {
            otherlv_0=(Token)match(input,14,FOLLOW_4); 

            			newLeafNode(otherlv_0, grammarAccess.getUserAccess().getUserKeyword_0());
            		
            // InternalMyDsl.g:242:3: ( (lv_name_1_0= RULE_ID ) )
            // InternalMyDsl.g:243:4: (lv_name_1_0= RULE_ID )
            {
            // InternalMyDsl.g:243:4: (lv_name_1_0= RULE_ID )
            // InternalMyDsl.g:244:5: lv_name_1_0= RULE_ID
            {
            lv_name_1_0=(Token)match(input,RULE_ID,FOLLOW_6); 

            					newLeafNode(lv_name_1_0, grammarAccess.getUserAccess().getNameIDTerminalRuleCall_1_0());
            				

            					if (current==null) {
            						current = createModelElement(grammarAccess.getUserRule());
            					}
            					setWithLastConsumed(
            						current,
            						"name",
            						lv_name_1_0,
            						"org.eclipse.xtext.common.Terminals.ID");
            				

            }


            }

            // InternalMyDsl.g:260:3: (otherlv_2= 'age' otherlv_3= '=' ( (lv_age_4_0= RULE_INT ) ) )?
            int alt2=2;
            int LA2_0 = input.LA(1);

            if ( (LA2_0==15) ) {
                alt2=1;
            }
            switch (alt2) {
                case 1 :
                    // InternalMyDsl.g:261:4: otherlv_2= 'age' otherlv_3= '=' ( (lv_age_4_0= RULE_INT ) )
                    {
                    otherlv_2=(Token)match(input,15,FOLLOW_7); 

                    				newLeafNode(otherlv_2, grammarAccess.getUserAccess().getAgeKeyword_2_0());
                    			
                    otherlv_3=(Token)match(input,16,FOLLOW_8); 

                    				newLeafNode(otherlv_3, grammarAccess.getUserAccess().getEqualsSignKeyword_2_1());
                    			
                    // InternalMyDsl.g:269:4: ( (lv_age_4_0= RULE_INT ) )
                    // InternalMyDsl.g:270:5: (lv_age_4_0= RULE_INT )
                    {
                    // InternalMyDsl.g:270:5: (lv_age_4_0= RULE_INT )
                    // InternalMyDsl.g:271:6: lv_age_4_0= RULE_INT
                    {
                    lv_age_4_0=(Token)match(input,RULE_INT,FOLLOW_2); 

                    						newLeafNode(lv_age_4_0, grammarAccess.getUserAccess().getAgeINTTerminalRuleCall_2_2_0());
                    					

                    						if (current==null) {
                    							current = createModelElement(grammarAccess.getUserRule());
                    						}
                    						setWithLastConsumed(
                    							current,
                    							"age",
                    							lv_age_4_0,
                    							"org.eclipse.xtext.common.Terminals.INT");
                    					

                    }


                    }


                    }
                    break;

            }


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleUser"

    // Delegated rules


 

    public static final BitSet FOLLOW_1 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_2 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_3 = new BitSet(new long[]{0x0000000000005802L});
    public static final BitSet FOLLOW_4 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_5 = new BitSet(new long[]{0x0000000000002000L});
    public static final BitSet FOLLOW_6 = new BitSet(new long[]{0x0000000000008002L});
    public static final BitSet FOLLOW_7 = new BitSet(new long[]{0x0000000000010000L});
    public static final BitSet FOLLOW_8 = new BitSet(new long[]{0x0000000000000020L});

}